<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_experience".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderExperience".
 *
 * Columns in table "provider_experience" available as properties of the model,
 * followed by relations of table "provider_experience" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property string $position
 * @property string $organization
 * @property string $from_date
 * @property string $to_date
 * @property string $description
 *
 * @property Provider $provider
 */
abstract class BaseProviderExperience extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_experience';
    }

    public static function representingColumn()
    {
        return 'organization';
    }

    public function rules()
    {
        return array(
            array('provider_id, organization', 'required'),
            array('provider_id, from_date, to_date', 'numerical', 'integerOnly' => true),
            array('position', 'length', 'max' => 70),
            array('organization', 'length', 'max' => 100),
            array('from_date, to_date', 'length', 'max' => 4),
            array('from_date', 'numerical', 'min' => 1900, 'max' => date('Y')),
            array('to_date', 'numerical', 'min' => 1900, 'max' => date('Y')),
            array('to_date', 'validYear'),
            array('description', 'length', 'max' => 255),
            array('to_date, from_date, description', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, position, organization, from_date, to_date, description', 'safe', 'on' => 'search'),
        );
    }

    public function validYear()
    {
        if ($this->to_date != '') {
            if ($this->to_date < $this->from_date) {
                $this->addError('to_date', utf8_encode('From date can\'t be after To date.'));
            }
        } elseif ($this->to_date == 'yyyy') {
            $this->to_date = null;
        }
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'position' => Yii::t('app', 'Position'),
            'organization' => Yii::t('app', 'Organization'),
            'from_date' => Yii::t('app', 'From Date'),
            'to_date' => Yii::t('app', 'To Date'),
            'description' => Yii::t('app', 'Description'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;
        $criteria->with = 'provider';

        //it will search by id or provider.first_last
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->compare('provider.first_last', $this->provider_id, true);
        } elseif (intval($this->provider_id)) {
            $criteria->compare('provider_id', $this->provider_id);
        }
        $criteria->compare('id', $this->id);
        $criteria->compare('position', $this->position, true);
        $criteria->compare('organization', $this->organization, true);
        $criteria->compare('from_date', $this->from_date, true);
        $criteria->compare('to_date', $this->to_date, true);
        $criteria->compare('description', $this->description, true);

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderExperience|ProviderExoeriences', $n);
    }

}
